<?php
/* $Id: function.inc.php 3540 2009-10-13 11:45:23Z vadim $ */

function s_browse_subscribes () {
  global $db, $admin_mode;
  global $AUTH_USER_ID, $HTTP_ROOT_PATH;
  global $browse_subscribes;
  global $current_sub, $current_cc;
  global $catalogue, $sub, $cc;

  $browse_template = $browse_subscribes;

  if (!$AUTH_USER_ID) return;

  $data = $db->get_results("SELECT a.`Subscriber_ID`, a.`Sub_Class_ID`, c.`Sub_Class_Name`, CONCAT(b.`Hidden_URL`, c.`EnglishName`, '.html') AS Subscription_URL, b.`Subdivision_ID`, b.`Subdivision_Name`, b.`Hidden_URL`, a.`Status`
    FROM `Subscriber` AS a, `Subdivision` AS b, `Sub_Class` AS c
    WHERE a.`User_ID` = '".$AUTH_USER_ID."'
      AND a.`Sub_Class_ID` = c.`Sub_Class_ID`
      AND c.`Subdivision_ID` = b.`Subdivision_ID` ".$browse_template['sortby'], ARRAY_A);
  $data_count = $db->num_rows;

  eval("\$result = \"".$browse_template['prefix']."\";");

  for ($i=0; $i<$data_count; $i++) {

    if ($data[$i]['Status']) {
      eval("\$result.= \"".$browse_template['active']."\";");
    }
    else {
      eval("\$result.= \"".$browse_template['unactive']."\";");
    }

    $prefix = $HTTP_ROOT_PATH."subscribe.php?catalogue=".$catalogue."&sub=".$sub.($cc ? "&cc=".$cc : "")."&id=".$data[$i]['Subscriber_ID'];

    $toggleLink = $prefix."&subscribeAction=toggle";
    $unsubscribeLink = $prefix."&subscribeAction=delete";

    $result = str_replace("%ID", $data[$i]['Subscriber_ID'], $result);
    $result = str_replace("%CC_ID", $data[$i]['Sub_Class_ID'], $result);
    $result = str_replace("%CC_NAME", $data[$i]['Sub_Class_Name'], $result);
    $result = str_replace("%CC_URL", $data[$i]['Subscription_URL'], $result);
    $result = str_replace("%SUB_ID", $data[$i]['Subdivision_ID'], $result);
    $result = str_replace("%SUB_NAME", $data[$i]['Subdivision_Name'], $result);
    $result = str_replace("%SUB_URL", $data[$i]['Hidden_URL'], $result);

    $result = str_replace("%TOGGLE_LINK", $toggleLink, $result);
    $result = str_replace("%UNSUBSCRIBE_LINK", $unsubscribeLink, $result);

    if ( $i <> ($data_count - 1) ) eval("\$result.= \"".$browse_template['divider']."\";");
  }

  eval("\$result.= \"".$browse_template['suffix']."\";");

  return $result;
}

function subscribe_addItem ($cc) {
  global $AUTH_USER_ID;
  global $db;

  if (!$AUTH_USER_ID) return false;

  // validate
  $cc = intval($cc);
  
  $count = $db->get_var("SELECT COUNT(*) FROM `Subscriber`
    WHERE `Sub_Class_ID` = '".$cc."' AND `User_ID` = '".$AUTH_USER_ID."'");

  if (!$count) $res = $db->query("INSERT INTO `Subscriber`
    (`User_ID`, `Status`, `Sub_Class_ID`)
    VALUES
    ('".$AUTH_USER_ID."', 1, '".$cc."')");

  return ($res);
}

function subscribe_deleteItem ($id) {
  global $AUTH_USER_ID;
  global $db;

  if (!$AUTH_USER_ID) return false;
  
  // validate
  $id = intval($id);
  
  $res = $db->query("DELETE FROM `Subscriber`
    WHERE `Subscriber_ID` = '".$id."' AND `User_ID` = '".$AUTH_USER_ID."'");

  return ($res);
}

function subscribe_toggleItem ($id) {
  global $AUTH_USER_ID;
  global $db;

  if (!$AUTH_USER_ID) return false;
  
  // validate
  $id = intval($id);
  
  $res = $db->query("UPDATE `Subscriber` SET `Status` = (1 - `Status`)
    WHERE `Subscriber_ID` = '".$id."' AND `User_ID` = '".$AUTH_USER_ID."'");

  return ($res);
}

function subscribe_sendmail ($cc, $mailbody) {
  global $db, $MODULE_VARS, $current_subclass;

  if (!$SPAM_FIELD = $MODULE_VARS['subscriber']['USER_EMAIL_FIELD']) return false;

  // validate
  $cc = intval($cc);
  
  $SPAM_FROM_NAME = $MODULE_VARS['subscriber']['SEND_FROM_NAME'];
  $SPAM_FROM = $MODULE_VARS['subscriber']['SEND_FROM_EMAIL'];

  $res = $db->get_col("SELECT b.`".$SPAM_FIELD."` FROM `Subscriber` AS a, `User` AS b
    WHERE a.`Sub_Class_ID` = '".$cc."' AND a.`User_ID` = b.`User_ID` AND a.`Status` = 1");
  
  if ( !empty($res) ) {
    foreach ($res as $usr_email) {
      $mailer = new CMIMEMail();
      $mailer->mailbody( strip_tags($mailbody), $mailbody );
      $mailer->send($usr_email, $SPAM_FROM_NAME, $SPAM_FROM, $MODULE_VARS['subscriber']['SUBJECT_CONTENT'], $SPAM_FROM_NAME);
    }
  }

}

function subscribe_checkItem($cc, $user_id = 0) {
  global $AUTH_USER_ID;
  global $db;
  
  // static storage
  static $storage = array();
  
  // validate
  $cc = intval($cc);
  $user_id = intval($user_id);
  
  // if no user set current user
  if (!$user_id) $user_id = $AUTH_USER_ID;
  // unknown user detected
  if (!$user_id) return false;

  if ( !isset($storage[$cc][$user_id]) ) {
    $storage[$cc][$user_id] = $db->get_var("SELECT `Subscriber_ID` FROM `Subscriber`
      WHERE `Sub_Class_ID` = '".$cc."' AND `User_ID` = '".$user_id."'");
  }
  
  // return result
  return $storage[$cc][$user_id];
}

?>