<?php
  /* $Id: tree_frame.php 3519 2009-09-30 11:33:05Z vadim $ */

  require("./function.inc.php");

  $sources = array(
	  'sitemap' => $ADMIN_PATH."subdivision/tree_json.php?node=",
	  'developer' => $ADMIN_PATH."dev_json.php?node=",
	  'modules' => $ADMIN_PATH."modules/modules_json.php?node=",
	  'users' => $ADMIN_PATH."user/user_json.php?node=",
	  //  --
	  'related_message' => $ADMIN_PATH."related/tree_json.php?mode=related_message&node=",
	  'related_subdivision' => $ADMIN_PATH."related/tree_json.php?mode=related_subdivision&node=",
	  'related_subclass' => $ADMIN_PATH."related/tree_json.php?mode=related_subclass&node=",

	  'wizard_subdivision' => $ADMIN_PATH."wizard/tree_json.php?mode=wizard_subdivision&node=",
	  'wizard_parentsub' => $ADMIN_PATH."wizard/tree_json.php?mode=wizard_parentsub&node=",

	  'copy_message' => $ADMIN_PATH."objects/tree_json.php?mode=copy_message&cc=".$cc."&classID=".$classID."&message=".$message."&node=",
	);

  $source = $sources[$_GET['mode']];

  if (!$source) exit('Wrong params');
?>
<html>
<head>
   <title>Tree Frame</title>
   <link rel='stylesheet' type='text/css' media='screen' href='<?=$ADMIN_TEMPLATE?>css/left_pane.css'>
   <script type='text/javascript'>
     var NETCAT_PATH = '<?=$SUB_FOLDER.$HTTP_ROOT_PATH?>',
         ADMIN_PATH = '<?=$ADMIN_PATH?>',
         ICON_PATH = '<?=$ADMIN_TEMPLATE?>' + 'img/';
   </script>
   <script type='text/javascript' src='<?=$ADMIN_PATH?>js/lib.js'></script>
   <script type='text/javascript' src='<?=$ADMIN_PATH?>js/tree_frame.js'></script>
</head>
<body style='overflow: hidden; overflow-y: auto'>
 <nobr>
  <div id='siteTreeContainer'>
   <ul id='siteTree'></ul>
  </div>
 </nobr>
 <script type='text/javascript'>
   new dynamicTree('tree', 'siteTree', '<?=$source ?>');
   <?php
     if ($_GET['selected_node']) print "tree.selectNode('".$_GET['selected_node']."');\n";
   ?>
 </script>
</body>
</html>