<?
/* $Id: s_class.inc.php 3580 2009-11-18 16:38:19Z vadim $ */

function opt($flag, $output) {
	if ($flag) return $output;
}

function opt_case($flag, $output1, $output2 = "") {
	if ($flag) {
		return $output1;
	}
	else {
		return $output2;
	}
}

function is_even($input) {
	if ( round($input / 2)==$input / 2 ) {
		return 0;
	}
	else {
		return 1;
	}
}


/**
 *     
 *
 * @param array   
 * @param int   
 * 
 * @global $browse_msg, $classPreview
 * 
 * : - $browse_msg   
 * 
 * @return string html-  
 */
function browse_messages($cc_env, $range) {
  global $browse_msg, $classPreview;
  
  // system superior object
  $nc_core = nc_Core::get_object();
  
  if ( isset($classPreview) ) $classPreview+= 0;
	
  if ( $cc_env['cur_cc'] == $nc_core->input->fetch_get("cur_cc") ) $curPos = $cc_env['curPos'] + 0;
	$maxRows = $cc_env['maxRows'];
	$totRows = $cc_env['totRows'];

	if ($cc_env['cur_cc']) $cur_cc = $cc_env['cur_cc'];

	if (!$maxRows || !$totRows) return;

	$page_count = ceil($totRows / $maxRows);
	$half_range = ceil($range / 2);
	$cur_page = ceil($curPos / $maxRows) + 1;

	if ($page_count < 2) return;

	$maybe_from = $cur_page - $half_range;
	$maybe_to = $cur_page + $half_range;

	if ($maybe_from < 0) {
		$maybe_to = $maybe_to - $maybe_from;
		$maybe_from = 0;

		if ($maybe_to > $page_count) $maybe_to = $page_count;
	}

	if ($maybe_to > $page_count) {
		$maybe_from = $page_count - $range;
		$maybe_to = $page_count;

		if ($maybe_from < 0) $maybe_from = 0;
	}

  // prefix
	eval("\$result = \"".$browse_msg['prefix']."\";");

	//  
	// const_url     
	$const_url = $cc_env['LocalQuery'];

	//    cur_cc
	if ( isset($cur_cc) ) $get_param['cur_cc'] = $cur_cc;

 	//  get-
  $_get_arr = $nc_core->input->fetch_get();
	if ( !empty($_get_arr) ) {
    $ignore_arr = array('sid', 'ced', 'inside_admin', 'catalogue', 'sub', 'cc', 'curPos', 'cur_cc', 'REQUEST_URI');
	  foreach ($_get_arr as $k => $v) {
	    if ( !in_array($k, $ignore_arr) ) $get_param[$k] = $v;
	  }  
	}

	$const_url .= $nc_core->url->build_url($get_param) ? ( strlen($const_url) > 1 ? "&" : "" ).$nc_core->url->build_url($get_param) : "";

	for ($i=$maybe_from; $i < $maybe_to; $i++) {
		$page_number = $i + 1;
		$page_from = $i * $maxRows;
		$page_to = $page_from + $maxRows;

		$url = $const_url.(strlen($const_url) > 1 ? "&" : "")."curPos=".$page_from;
    // clear already existance &amp; and replace all & to &amp; view
    $url = preg_replace( array("/&amp;/", "/&/"), array("&", "&amp;"), $url);

		if ($curPos == $page_from) {
		  eval("\$result .= \"".$browse_msg['active']."\";"); 
		} 
		else {
		  eval("\$result .= \"".$browse_msg['unactive']."\";");
		}

		$result = str_replace("%URL", $url, $result);
		$result = str_replace("%PAGE", $page_number, $result);
		$result = str_replace("%FROM", $page_from + 1, $result);
		$result = str_replace("%TO", $page_to, $result);

		if ($i!=($maybe_to-1)) eval("\$result .= \"".$browse_msg['divider']."\";");
	}
	
	eval("\$result .= \"".$browse_msg['suffix']."\";");

	return $result;
}

function parentofmessage($message,$classID) {
	global $db;

	$parent = $message;

	while ($parent) {
		$old_parent = $parent;

		$parent = $db->get_var("SELECT Parent_Message_ID FROM Message".$classID." WHERE Message_ID='".$parent."'");
	}

	return $old_parent;
}

?>